/**
* This file is part of the XVM project.
*
* Copyright (c) 2017-2021 XVM contributors.
*
* This file is free software: you can redistribute it and/or modify
* it under the terms of the GNU Lesser General Public License as
* published by the Free Software Foundation, version 3.
*
* This file is distributed in the hope that it will be useful, but
* WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
* Lesser General Public License for more details.
*
* You should have received a copy of the GNU Lesser General Public License
* along with this program. If not, see <http://www.gnu.org/licenses/>.
*/

#pragma once

#include <Windows.h>

#ifdef __cplusplus
extern "C"
{
#endif

extern const int Functions_Count;
extern const int Structures_Count;

enum FunctionsEnum
{
<<FUNCTIONS_NAMES>>
};

enum StructuresEnum
{
<<STRUCTURES_NAMES>>
};


extern char* Functions_Names[<<FUNCTIONS_COUNT>>];
extern DWORD Functions_SignatureCount[<<FUNCTIONS_COUNT>>];
extern char* Functions_SignatureData[<<FUNCTIONS_COUNT>>][<<FUNCTIONS_SIGNATURES_MAXCOUNT>>];
extern char* Functions_SignatureMask[<<FUNCTIONS_COUNT>>][<<FUNCTIONS_SIGNATURES_MAXCOUNT>>];

extern char* Structures_Names[<<STRUCTURES_COUNT>>];

extern DWORD Structures_SignatureCount[<<STRUCTURES_COUNT>>];
extern DWORD Structures_SignatureFunctionIndex[<<STRUCTURES_COUNT>>][<<STRUCTURES_SIGNATURES_MAXCOUNT>>];
extern DWORD Structures_SignatureOffset[<<STRUCTURES_COUNT>>][<<STRUCTURES_SIGNATURES_MAXCOUNT>>];
extern char* Structures_SignatureValidationPrefixData[<<STRUCTURES_COUNT>>][<<STRUCTURES_SIGNATURES_MAXCOUNT>>];
extern char* Structures_SignatureValidationPrefixMask[<<STRUCTURES_COUNT>>][<<STRUCTURES_SIGNATURES_MAXCOUNT>>];

#ifdef __cplusplus
}
#endif